package kr.pe.theeye.listview;

import java.util.ArrayList;

import android.app.Activity;
import android.content.Context;
import android.os.Bundle;
import android.os.Handler;
import android.util.Log;
import android.view.LayoutInflater;
import android.widget.AbsListView;
import android.widget.AbsListView.OnScrollListener;
import android.widget.ListView;

public class DynamicListViewActivity extends Activity implements OnScrollListener
{
	private static final String LOG = "DynamicListViewActivity";
	private CustomAdapter mAdapter;
	private ListView mListView;
	private LayoutInflater mInflater;
	private ArrayList<String> mRowList;
	private boolean mLockListView;
	
    @Override
    public void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
        //   ʱȭ
        mRowList = new ArrayList<String>();
        mLockListView = true;
        
        // Ϳ Ʈ ʱȭ
        mAdapter = new CustomAdapter(this, R.layout.row, mRowList);
        mListView = (ListView) findViewById(R.id.listView);
        
        // Ǫ͸ մϴ. setAdapter  ؾ մϴ. 
        mInflater = (LayoutInflater) getSystemService(Context.LAYOUT_INFLATER_SERVICE);
        mListView.addFooterView(mInflater.inflate(R.layout.footer, null));
        
        // ũ ʸ մϴ. onScroll ߰ ݴϴ.
        mListView.setOnScrollListener(this);
        mListView.setAdapter(mAdapter);
        
        // ̵͸ ߰ϱ  Ƿ  ޼ ȣ
        addItems(50);
	}

	@Override
	public void onScroll(AbsListView view, int firstVisibleItem, int visibleItemCount, int totalItemCount)
	{
		//   ó ̴ ȣ  ȣ Ѱ ü ڿ   Ʒ ũ Ǿٰ
		// մϴ.
		int count = totalItemCount - visibleItemCount;

		if(firstVisibleItem >= count && totalItemCount != 0 && mLockListView == false)
		{
			Log.i(LOG, "Loading next items");
			addItems(50);
		}	
	}

	@Override
	public void onScrollStateChanged(AbsListView view, int scrollState)
	{
	}
	
	/**
	 *     ߰մϴ.
	 * 
	 * @param size
	 */
	private void addItems(final int size)
	{
		//  ߰ϴ  ߺ û ϱ   ɾӴϴ.
		mLockListView = true;
		
		Runnable run = new Runnable()
		{
			@Override
			public void run()
			{
				for(int i = 0 ; i < size ; i++)
				{
					mRowList.add("Item " + i);
				}
				
				//  ͸ εϿ Ͽٸ Ϳ ˸ Ʈ  մϴ.
				mAdapter.notifyDataSetChanged();
				mLockListView = false;
			}
		};
		
		// ӵ ̸ ϱ  ļ
		Handler handler = new Handler();
		handler.postDelayed(run, 5000);
	}
}